package comparison;

import java.lang.Math;

/**
 * created by as part of comparison
 * User: mac
 * Date: 03.08.2009
 * Time: 22:46:55
 */
public class ACCEuclidean extends ACComparison
{
    public ACCEuclidean()
    {
        CName = "Euclidean Distance";
        CType = TYPE_DOUBLEVECT;
    }

    public double compareString(String x, String y)
    {
        return 0;
    }

    public double compareDoublevect(double[] x, double[] y)
    {
        double[] large, small;

        //get longer array

        large = x;
        small = y;

        if (x.length < y.length)
        {
            large = y;
            small = x;
        }

        int lendiff = large.length - small.length;
        double dist = 0;

                //move small string over large sting in same size window, compute distance
        for (int i = 0; i <= lendiff; i++)
        {
            double ed = 0; //to be euclidean distance of this window
            double maxed = 0;

            for (int j = 0; j < small.length; j++)
            {
                ed +=  (small[j] - large[i+j]) * (small[j] - large[i+j]);
                maxed += Math.max(small[j], large[i+j]) * Math.max(small[j], large[i+j]);
            }

            ed = Math.sqrt(ed);
            maxed = Math.sqrt(maxed);

            System.out.println("ed=" + ed + "/maxed=" + maxed);
            System.out.println("ed/maxed=" + (ed/maxed));
            //this version: minimum window distance
            if ( (1-(ed/maxed)) > dist) dist = 1-(ed/maxed);
            
        }


        return dist;// / (double)lendiff; //percentage of distance
    }
}
